"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const assetsPath = '../assets';
class FileManager {
    static getHtmlTemplate() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield FileManager.readFile(`${__dirname}/${assetsPath}/elearnjs/template.html`);
        });
    }
    static getPdfTemplate() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield FileManager.readFile(`${__dirname}/${assetsPath}/elearnjs/template_pdf.html`);
        });
    }
    /**
     * Reads in a given file.
     */
    static readFile(filePath) {
        let ret = new Promise((resolve, reject) => {
            fs.readFile(filePath, 'utf8', (err, data) => {
                // will not reject, because it is only used by tested methods above
                resolve(data);
            });
        });
        return ret;
    }
}
exports.FileManager = FileManager;
