// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../puppeteer
//   ../fs

declare module 'markdown-elearnjs' {
    /**
      * Export everything necessary
      */
    export * from 'markdown-elearnjs/converter/HtmlConverter';
    export * from 'markdown-elearnjs/converter/PdfConverter';
    export * from 'markdown-elearnjs/ExtensionManager';
    export * from 'markdown-elearnjs/FileExtractor';
    export * from 'markdown-elearnjs/FileExtractorObject';
    export * from 'markdown-elearnjs/FileMoveObject';
    export * from 'markdown-elearnjs/objects/export/ConversionObject';
    export * from 'markdown-elearnjs/objects/export/HtmlExportOptionObject';
    export * from 'markdown-elearnjs/objects/export/InclusionObject';
    export * from 'markdown-elearnjs/objects/export/PdfExportOptionObject';
    export * from 'markdown-elearnjs/objects/export/ExtensionObject';
    export * from 'markdown-elearnjs/objects/settings/ConverterSettingsObject';
    export * from 'markdown-elearnjs/objects/settings/PdfSettingsObject';
}

declare module 'markdown-elearnjs/converter/HtmlConverter' {
    import { ConversionObject } from 'markdown-elearnjs/objects/export/ConversionObject';
    import { HtmlExportOptionObject } from 'markdown-elearnjs/objects/export/HtmlExportOptionObject';
    import { ConverterSettingsObject } from 'markdown-elearnjs/objects/settings/ConverterSettingsObject';
    import { AConverter } from 'markdown-elearnjs/converter/AConverter';
    import { IConverter } from 'markdown-elearnjs/converter/IConverter';
    import { IShowdownConverter } from 'markdown-elearnjs/converter/IShowdownConverter';
    /**
        * Converts Markdown to elearnjs HTML
        */
    export class HtmlConverter extends AConverter implements IConverter {
            protected converter: IShowdownConverter;
            /**
                * Creates an HtmlConverter with specific options.
                * @param {ConverterSettingsObject} options: optional options
                */
            constructor(options?: ConverterSettingsObject);
            toHtml(markdown: string, options?: ConversionObject): Promise<string>;
            /**
                * Converts given markdown to a PDF File.
                * Certain options will specify the output.
                *
                * @param markdown: string - the markdown code
                * @param file: string - the output file path (including file name)
                * @param rootPath: string - the root path for relative paths in the file.
                * @param {HtmlExportOptionObject} options: optional options
                * @param forceOverwrite: bool - if an existing file should be overwritten.
                *
                * @return {Promise<string>} - will resolve with the path when done. (err) when an error occurred.
                */
            toFile(markdown: string, file: string, rootPath: string, options?: HtmlExportOptionObject, forceOverwrite?: boolean): Promise<string>;
    }
}

declare module 'markdown-elearnjs/converter/PdfConverter' {
    import { ConversionObject } from 'markdown-elearnjs/objects/export/ConversionObject';
    import { PdfExportOptionObject } from 'markdown-elearnjs/objects/export/PdfExportOptionObject';
    import { PdfSettingsObject } from 'markdown-elearnjs/objects/settings/PdfSettingsObject';
    import { AConverter } from 'markdown-elearnjs/converter/AConverter';
    import { IConverter } from 'markdown-elearnjs/converter/IConverter';
    import { IShowdownConverter } from 'markdown-elearnjs/converter/IShowdownConverter';
    /**
        * Converts Markdown to elearnjs PDF
        */
    export class PdfConverter extends AConverter implements IConverter {
            protected converter: IShowdownConverter;
            /**
                * Creates a PdfConverter with specific options.
                * @param {PdfSettingsObject} options: optional options
                */
            constructor(options?: PdfSettingsObject);
            setOption(opt: string, val: any): void;
            /**
                * Update multiple conversion options.
                * @param options: Object - same as in the constructor
                */
            setOptions(options: PdfSettingsObject): void;
            toHtml(markdown: string, options?: ConversionObject): Promise<string>;
            /**
                * Converts given markdown to an HTML string for an HTML to PDF conversion.
                * Certain options will specify the output.
                *
                * @deprecated use `.toHtml` instead
                *
                * @param markdown: string - the markdown code
                * @param {ConversionObject} options: optional options
                *
                * @return {Promise<string>} - will resolve with the output html, when done.
                */
            toPdfHtml(markdown: string, options?: ConversionObject): Promise<string>;
            /**
                * Converts given markdown to a PDF File.
                * Certain options will specify the output.
                *
                * @param markdown: string - the markdown code
                * @param file: string - the output file path (including file name)
                * @param rootPath: string - the root path for relative paths in the file.
                * @param {PdfExportOptionObject} options: optional options
                * @param forceOverwrite: bool - if an existing file should be overwritten.
                *
                * @return {Promise<string>} - will resolve with the path when done. (err) when an error occurred.
                */
            toFile(markdown: string, file: string, rootPath: string, options?: PdfExportOptionObject, forceOverwrite?: boolean): Promise<string>;
            /**
                * Converts given markdown to a pdf file buffer.
                * Certain options will specify the output.
                *
                * This will instantiate a chromium browser instance if not present already.
                * Changing the converter options with `setOption` or `setOptions`,
                * as well as starting another conversion process before resolving of this
                * function, might lead to unwanted behavior.
                *
                * @param markdown: string - the markdown code
                * @param file: string - the output file path (including file name)
                * @param rootPath: string - the root path for relative paths in the file.
                * @param {PdfExportOptionObject} options: optional options
                *
                * @return Promise: (stream) - will resolve when done. (err) when an error occurred.
                */
            toBuffer(markdown: string, rootPath: string, options?: PdfExportOptionObject): Promise<Buffer>;
            /**
                * Returns if the Converter has a browser instance. This instance might
                * be still in startup.
                * Will only return false if there is neither a working instance nor an
                * instance starting.
                *
                * @return whether an available or starting instance is present (true) or not (false)
                */
            hasBrowserInstance(): boolean;
    }
}

declare module 'markdown-elearnjs/ExtensionManager' {
    import { IConverter } from 'markdown-elearnjs/converter/IConverter';
    import { ExtensionObject } from 'markdown-elearnjs/objects/export/ExtensionObject';
    /**
        * Allows to parse HTML code for usage of elearn.js extensions.
        * Allows to get path to extension necessary files.
        * Allows to get include strings for extension necessary files.
        */
    export class ExtensionManager {
            static scanForQuiz(html: string): boolean;
            static scanForVideo(html: string): boolean;
            static scanForClickImage(html: string): boolean;
            static scanForTimeSlider(html: string): boolean;
            /**
                * Scans the html code for elearn.js extensions.
                *
                * @param html string: the html code to be scanned
                *
                * @return ExtensionObject: including which extensions were found
                * and explicitly which were not found (true/false)
                */
            static scanHtmlForAll(html: string): ExtensionObject;
            /**
                * Scans the markdown code for elearn.js extensions.
                *
                * @param markdown string: the original markdown code to be scanned
                * @param IConverter (optional) HtmlConverter or PdfConverter:
                *  the converter to use for markdown to HTML conversion. If not given,
                *  a default HtmlConverter will be used.
                *
                * @return Promise<ExtensionObject>: including which extensions were found
                * and explicitly which were not found (true/false)
                */
            static scanMarkdownForAll(markdown: string, markdownConverter?: IConverter): Promise<ExtensionObject>;
            static getHTMLAssetStrings(includeQuiz?: boolean, includeElearnVideo?: boolean, includeClickImage?: boolean, includeTimeSlider?: boolean): string;
            static getPDFAssetStrings(includeQuiz?: boolean, includeElearnVideo?: boolean, includeClickImage?: boolean, includeTimeSlider?: boolean): string;
            /**
                * Writes the elearn.js assets to the given path.
                * @param dirPath: string - the path to write the `assets` folder to.
                * @param {ExtensionObject} opts optional options
                */
            static exportAssets(dirPath: string, opts: ExtensionObject): Promise<void>;
    }
}

declare module 'markdown-elearnjs/FileExtractor' {
    import { FileExtractorObject } from 'markdown-elearnjs/FileExtractorObject';
    import { FileMoveObject } from 'markdown-elearnjs/FileMoveObject';
    /**
        * Used for the extraction of linked files in the HTML.
        * This will be used to copy user linked files to the output directory and
        * update the HTML.
        */
    export class FileExtractor {
            /**
                * Copies all files given by their FileMoveObjects from their inputRoot
                * to the outputRoot.
                * @param files the files to copy
                * @param inputRoot the root for relative paths as input
                * @param outputRoot the root directory to copy the files to
                * @param timeout an optional timeout in ms.
                */
            static extractAll(files: FileMoveObject[], inputRoot: string, outputRoot: string, timeout?: number): Promise<void>;
            /**
                * Replace all links in the HTML. This will assert that the files
                * were extracted to a `assets` folder.
                * The returned `FileExtractorObject` will contain the updated HTML with
                * relative paths to the assets folder and a list of `FileMoveObject`s
                * used by `extractAll()` to actually extract the files.
                * @param html the html to change
                */
            static replaceAllLinks(html: string): FileExtractorObject;
    }
}

declare module 'markdown-elearnjs/FileExtractorObject' {
    import { FileMoveObject } from "markdown-elearnjs/FileMoveObject";
    /**
        * Used to return information about file extraction process.
        * Contains changed HTML (replaced relative links)
        * and found files.
        */
    export class FileExtractorObject {
            html: string;
            files: FileMoveObject[];
            /**
                * @param html: string of html after fileExtraction,
                *              all `files` are changed in the html.
                *              if `files` is empty, the html was not changed by the
                *              FileExtractor parsing
                * @param files: FileMoveObject[], containing multiple files of type
                *               {inputPath: ..., relativeOutputPath: ...}
                */
            constructor(html: string, files: FileMoveObject[]);
    }
}

declare module 'markdown-elearnjs/FileMoveObject' {
    /**
        * An object declaring necessary information for a move of a file.
        */
    export class FileMoveObject {
            /**
                * The path (including file name) to the file. This might be an absolute
                * path or relative to some root path. If relative the root path is
                * necessary when actually copying the file.
                */
            inputPath: string;
            /**
                * The relative output path. This one is always relative from a generated
                * output root path. The root path usually contains the generated assets
                * folder.
                * This relative path usually starts with `assets/`.
                */
            relativeOutputPath: string;
            constructor(inputPath: string, relativeOutputPath: string);
    }
}

declare module 'markdown-elearnjs/objects/export/ConversionObject' {
    import { InclusionObject } from "markdown-elearnjs/objects/export/InclusionObject";
    /**
        * An object containing information about included extensions, selected language
        * and additional conversion options, like `bodyOnly`,
        * `automaticExtensionDetection` and `removeComments`.
        *
        * Extending the `InclusionObject`
        */
    export class ConversionObject extends InclusionObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * bodyOnly will only return the HTML body.
                * Default: false
                */
            bodyOnly?: boolean;
            /**
                * automaticExtensionDetection will scan for extensions and
                * include only those found. Will only autodetect extensions with
                * undefined as `includeEXTENSION` value.
                * Only if not `bodyOnly`
                * Default: false
                */
            automaticExtensionDetection?: boolean;
            /**
                * Whether to remove all HTML comments from the conversion output.
                * Default: false - no removal.
                */
            removeComments?: boolean;
            /**
                * An Object containing options for the general conversions
                * of the HtmlConverter and PdfConverter functions.
                *
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: ConversionObject);
    }
}

declare module 'markdown-elearnjs/objects/export/HtmlExportOptionObject' {
    import { ConversionObject } from "markdown-elearnjs/objects/export/ConversionObject";
    /**
        * An object containing all necessary information for the HTML conversion process.
        *
        * Extending the `ConversionObject`
        */
    export class HtmlExportOptionObject extends ConversionObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * if set to true the elearn.js assets containing
                * all included extensions will be exported next to the output file.
                */
            exportAssets?: boolean;
            /**
                * if set to true all linked files
                * detected by the `FileExtractor` will be exported to the assets next
                * to the output file.
                */
            exportLinkedFiles?: boolean;
            /**
                * An Object containing options for the general conversions
                * of the HtmlConverter and PdfConverter functions.
                *
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: HtmlExportOptionObject);
    }
}

declare module 'markdown-elearnjs/objects/export/InclusionObject' {
    import { ExtensionObject } from "markdown-elearnjs/objects/export/ExtensionObject";
    /**
        * An object containing information about the included extensions as well
        * as the selected language.
        *
        * Extending the `ExtensionObject`
        */
    export class InclusionObject extends ExtensionObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * Language key.
                * Default: "en"
                */
            language?: "en" | "de";
            /**
                * An Object containing options for the general conversions
                * of the HtmlConverter and PdfConverter functions.
                *
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: InclusionObject);
    }
}

declare module 'markdown-elearnjs/objects/export/PdfExportOptionObject' {
    import { ConversionObject } from "markdown-elearnjs/objects/export/ConversionObject";
    /**
        * An object containing all necessary information for the PDF conversion process.
        *
        * Extending the `ConversionObject`
        */
    export class PdfExportOptionObject extends ConversionObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * delay of rendering the html to pdf in ms
                */
            renderDelay?: number;
            /**
                * An Object containing options for the general conversions
                * of the HtmlConverter and PdfConverter functions.
                *
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: PdfExportOptionObject);
    }
}

declare module 'markdown-elearnjs/objects/export/ExtensionObject' {
    import { AInheritingObject } from "markdown-elearnjs/objects/AInheritingObject";
    /**
        * An object containing infos about included extensions.
        */
    export class ExtensionObject extends AInheritingObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * includeQuiz will include the import of the quiz.js in the head.
                * The script has to be located under `./assets`
                * This might be ignored in certain conditions when `bodyOnly` is set
                * to true.
                * Default: false
                */
            includeQuiz?: boolean;
            /**
                * includeElearnVideo will include the import of the
                * elearnvideo.js in the head. The script has to be located under `./assets`
                * This might be ignored in certain conditions when `bodyOnly` is set
                * to true.
                * Default: undefined. Will only be overwritten by `automaticExtensionDetection` if undefined.
                */
            includeElearnVideo?: boolean;
            /**
                * includeClickImage will include the import of the clickimage.js
                * in the head. The script has to be located under `./assets`
                * This might be ignored in certain conditions when `bodyOnly` is set
                * to true.
                * Default: undefined. Will only be overwritten by `automaticExtensionDetection` if undefined.
                */
            includeClickImage?: boolean;
            /**
                * includeTimeSlider will include the import of the timeslider.js
                * in the head. The script has to be located under `./assets`
                * This might be ignored in certain conditions when `bodyOnly` is set
                * to true.
                * Default: undefined. Will only be overwritten by `automaticExtensionDetection` if undefined.
                */
            includeTimeSlider?: boolean;
            /**
                * An Object containing options for the general conversions
                * of the HtmlConverter and PdfConverter functions.
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: ExtensionObject);
    }
}

declare module 'markdown-elearnjs/objects/settings/ConverterSettingsObject' {
    import { AInheritingObject } from "markdown-elearnjs/objects/AInheritingObject";
    /**
        * An object containing general converter settings. These apply for the
        * HtmlConverter and the PdfConverter but might be extended by specific objects.
        */
    export class ConverterSettingsObject extends AInheritingObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * Whether sections are automatically created at headings.
                * Default: true
                */
            newSectionOnHeading?: boolean;
            /**
                * until which depth headings are created.
                * Default: 3 (H3)
                */
            headingDepth?: 1 | 2 | 3 | 4 | 5 | 6;
            /**
                * Whether sub- and subsubsections are created
                * at a specific heading level (subSectionLevel, subsubSectionLevel)
                * Default: true.
                */
            useSubSections?: boolean;
            /**
                * level from which on created sections are subsections.
                * Default: 3 (H3)
                */
            subSectionLevel?: 1 | 2 | 3 | 4 | 5 | 6;
            /**
                * level from which on sections are subsubsections.
                * Default: 4 (H4) (will not be created with everything as default)
                */
            subsubSectionLevel?: 1 | 2 | 3 | 4 | 5 | 6;
            /**
                * An Object containing options for the general Converters
                *
                * @param {object} options: Manual values for this objects fields. All optional.
                */
            constructor(options?: ConverterSettingsObject);
    }
}

declare module 'markdown-elearnjs/objects/settings/PdfSettingsObject' {
    import Puppeteer from 'puppeteer';
    import { ConverterSettingsObject } from "markdown-elearnjs/objects/settings/ConverterSettingsObject";
    /**
        * An object extending the general `ConverterSettingsObject` by specific PDF
        * settings.
        */
    export class PdfSettingsObject extends ConverterSettingsObject {
            protected static readonly CLASS_KEYS: string[];
            /**
                * will add page breaks before every section
                */
            newPageOnSection?: boolean;
            /**
                * zoom factor for the page rendering
                */
            contentZoom?: number;
            /**
                * HTML of a custom page header
                */
            customHeader?: string;
            /**
                * HTML of a custom page footer
                */
            customFooter?: string;
            /**
                * CSS declaration of the header's height
                */
            headerHeight?: string;
            /**
                * CSS declaration of the footer's height
                */
            footerHeight?: string;
            /**
                * absolute path to a styling css file
                */
            customStyleFile?: string;
            /**
                * absolute path to the chrome executable.
                * See https://github.com/GoogleChrome/puppeteer#default-runtime-settings
                */
            chromePath?: string;
            /**
                * Options used to launch puppeteer.
                * See https://pptr.dev/#?product=Puppeteer&version=v1.8.0&show=api-puppeteerlaunchoptions
                *
                * The `Puppeteer.LaunchOptions.executablePath` might be overwritten by
                * the option `chromePath` if set.
                */
            puppeteerOptions?: Puppeteer.LaunchOptions;
            /**
                * If set to true, the chrome browser process used in the `PdfConverter`
                * will be kept running until the option is set to false again.
                * Otherwise the browser will close automatically after conversion.
                */
            keepChromeAlive?: boolean;
            /**
                * An Object containing options for the PdfConverter
                *
                *  @param {PdfSettingsObject} options:
                *      Manual values for this objects fields. All optional.
                */
            constructor(options?: PdfSettingsObject);
    }
}

declare module 'markdown-elearnjs/converter/AConverter' {
    import fs from "fs";
    import { ConversionObject } from "markdown-elearnjs/objects/export/ConversionObject";
    import { ConverterSettingsObject } from "markdown-elearnjs/objects/settings/ConverterSettingsObject";
    import { IConverter } from "markdown-elearnjs/converter/IConverter";
    import { IShowdownConverter } from "markdown-elearnjs/converter/IShowdownConverter";
    /**
        * Contains basic implementations used in the actual converters.
        */
    export abstract class AConverter implements IConverter {
            /**
                * The converter used for the main body markdown conversion.
                */
            protected abstract converter: IShowdownConverter;
            abstract toHtml(markdown: string, options?: ConversionObject): Promise<string>;
            abstract toFile(markdown: string, file: string, rootPath: string, options?: ConversionObject, forceOverwrite?: boolean): Promise<string>;
            getOption(opt: string): any;
            setOption(opt: string, val: any): void;
            setOptions(options: ConverterSettingsObject): void;
            /**
                * Checks if the file can be opened in writing mode. Can be used to
                * check if a file is opened in another process before trying to overwrite
                * it.
                *
                * @param file a pathlike parameter declaring the file to check.
                *
                * @return a promise resolved if it can be opened.
                * Rejected with the error if not.
                */
            protected tryFileOpen(file: fs.PathLike): Promise<void>;
    }
}

declare module 'markdown-elearnjs/converter/IConverter' {
    import { ConversionObject } from "markdown-elearnjs/objects/export/ConversionObject";
    import { ConverterSettingsObject } from "markdown-elearnjs/objects/settings/ConverterSettingsObject";
    /**
        * The general Converter interface. This might be extended in the implementing
        * elements.
        */
    export interface IConverter {
            /**
                * Converts given markdown to an HTML string.
                * Certain options will specify the output.
                *
                * @param markdown: string - the markdown code
                * @param {ConversionObject} options: optional options
                *
                * @return {Promise<string>} - will resolve with the output html, when done.
                */
            toHtml(markdown: string, options?: ConversionObject): Promise<string>;
            /**
                * Converts given markdown to a PDF File.
                * Certain options will specify the output.
                *
                * @param markdown: string - the markdown code
                * @param file: string - the output file path (including file name)
                * @param rootPath: string - the root path for relative paths in the file.
                * @param {ConversionObject} options: optional options
                * @param forceOverwrite: bool - if an existing file should be overwritten.
                *
                * @return {Promise<string>} - will resolve with the path when done. (err) when an error occurred.
                */
            toFile(markdown: string, file: string, rootPath: string, options?: ConversionObject, forceOverwrite?: boolean): Promise<string>;
            /**
                * Get the value of a specific option key.
                * @param opt The opt to check.
                */
            getOption(opt: string): any;
            /**
                * Update one of the conversion options.
                *
                * @param opt: string - option key. Same possible as in the constructor.
                * @param val: obj - the value to set the option to.
                */
            setOption(opt: string, val: any): void;
            /**
                * Update multiple conversion options.
                * @param options: Object - same as in the constructor
                */
            setOptions(options: ConverterSettingsObject): void;
    }
}

declare module 'markdown-elearnjs/converter/IShowdownConverter' {
    /**
        * Defines necessary methods used on the Showdown.Converter.
        * This makes type imports for Showdown unnecessary for developers using this
        * package.
        */
    export interface IShowdownConverter {
            /**
                * @param text The input text (markdown)
                * @return The output HTML
                */
            makeHtml(text: string): string;
            /**
                * Setting a "local" option only affects the specified Converter object.
                *
                * @param optionKey
                * @param value
                */
            setOption(optionKey: string, value: any): void;
            /**
                * Get the option of this Converter instance.
                *
                * @param optionKey
                */
            getOption(optionKey: string): any;
    }
}

declare module 'markdown-elearnjs/objects/AInheritingObject' {
    /**
        * An object which can inherit values from a given object based on a set
        * of defined keys. Other values will be omitted.
        */
    export abstract class AInheritingObject {
            [key: string]: any;
            protected static readonly CLASS_KEYS: string[];
            constructor(values?: {
                    [key: string]: any;
            });
            /**
                * Copy only the defined `keys` from the `values` object into this.
                * @param keys list of allowed keys
                * @param values object
                */
            protected static inheritValues(target: any, keys: string[], values?: {
                    [key: string]: any;
            }): void;
    }
}

