/**
 * An object which can inherit values from a given object based on a set
 * of defined keys. Other values will be omitted.
 */
export declare abstract class AInheritingObject {
    [key: string]: any;
    protected static readonly CLASS_KEYS: string[];
    constructor(values?: {
        [key: string]: any;
    });
    /**
     * Copy only the defined `keys` from the `values` object into this.
     * @param keys list of allowed keys
     * @param values object
     */
    protected static inheritValues(target: any, keys: string[], values?: {
        [key: string]: any;
    }): void;
}
