"use strict";
/**
 * An object which can inherit values from a given object based on a set
 * of defined keys. Other values will be omitted.
 */
Object.defineProperty(exports, "__esModule", { value: true });
class AInheritingObject {
    constructor(values) {
        AInheritingObject.inheritValues(this, AInheritingObject.CLASS_KEYS, values);
    }
    /**
     * Copy only the defined `keys` from the `values` object into this.
     * @param keys list of allowed keys
     * @param values object
     */
    static inheritValues(target, keys, values) {
        if (values) {
            Object.keys(values).forEach((key) => {
                if (keys.indexOf(key) >= 0) {
                    target[key] = values[key];
                }
            });
        }
    }
}
AInheritingObject.CLASS_KEYS = [];
exports.AInheritingObject = AInheritingObject;
