import { ConversionObject } from "./ConversionObject";
/**
 * An object containing all necessary information for the HTML conversion process.
 *
 * Extending the `ConversionObject`
 */
export declare class HtmlExportOptionObject extends ConversionObject {
    protected static readonly CLASS_KEYS: string[];
    /**
     * if set to true the elearn.js assets containing
     * all included extensions will be exported next to the output file.
     */
    exportAssets?: boolean;
    /**
     * if set to true all linked files
     * detected by the `FileExtractor` will be exported to the assets next
     * to the output file.
     */
    exportLinkedFiles?: boolean;
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options?: HtmlExportOptionObject);
}
