"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AInheritingObject_1 = require("../AInheritingObject");
const ConversionObject_1 = require("./ConversionObject");
/**
 * An object containing all necessary information for the HTML conversion process.
 *
 * Extending the `ConversionObject`
 */
class HtmlExportOptionObject extends ConversionObject_1.ConversionObject {
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options) {
        super(options);
        /**
         * if set to true the elearn.js assets containing
         * all included extensions will be exported next to the output file.
         */
        this.exportAssets = false;
        /**
         * if set to true all linked files
         * detected by the `FileExtractor` will be exported to the assets next
         * to the output file.
         */
        this.exportLinkedFiles = false;
        AInheritingObject_1.AInheritingObject.inheritValues(this, HtmlExportOptionObject.CLASS_KEYS, options);
    }
}
HtmlExportOptionObject.CLASS_KEYS = [
    "exportAssets",
    "exportLinkedFiles",
];
exports.HtmlExportOptionObject = HtmlExportOptionObject;
