import { ExtensionObject } from "./ExtensionObject";
/**
 * An object containing information about the included extensions as well
 * as the selected language.
 *
 * Extending the `ExtensionObject`
 */
export declare class InclusionObject extends ExtensionObject {
    protected static readonly CLASS_KEYS: string[];
    /**
     * Language key.
     * Default: "en"
     */
    language?: "en" | "de";
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options?: InclusionObject);
}
