"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AInheritingObject_1 = require("../AInheritingObject");
const ExtensionObject_1 = require("./ExtensionObject");
/**
 * An object containing information about the included extensions as well
 * as the selected language.
 *
 * Extending the `ExtensionObject`
 */
class InclusionObject extends ExtensionObject_1.ExtensionObject {
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options) {
        super(options);
        /**
         * Language key.
         * Default: "en"
         */
        this.language = "en";
        AInheritingObject_1.AInheritingObject.inheritValues(this, InclusionObject.CLASS_KEYS, options);
    }
}
InclusionObject.CLASS_KEYS = [
    "language",
];
exports.InclusionObject = InclusionObject;
