import { ConversionObject } from "./ConversionObject";
/**
 * An object containing all necessary information for the PDF conversion process.
 *
 * Extending the `ConversionObject`
 */
export declare class PdfExportOptionObject extends ConversionObject {
    protected static readonly CLASS_KEYS: string[];
    /**
     * delay of rendering the html to pdf in ms
     */
    renderDelay?: number;
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options?: PdfExportOptionObject);
}
