"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AInheritingObject_1 = require("../AInheritingObject");
const ConversionObject_1 = require("./ConversionObject");
/**
 * An object containing all necessary information for the PDF conversion process.
 *
 * Extending the `ConversionObject`
 */
class PdfExportOptionObject extends ConversionObject_1.ConversionObject {
    /**
     * An Object containing options for the general conversions
     * of the HtmlConverter and PdfConverter functions.
     *
     * @param {object} options: Manual values for this objects fields. All optional.
     */
    constructor(options) {
        super(options);
        /**
         * delay of rendering the html to pdf in ms
         */
        this.renderDelay = 0;
        AInheritingObject_1.AInheritingObject.inheritValues(this, PdfExportOptionObject.CLASS_KEYS, options);
    }
}
PdfExportOptionObject.CLASS_KEYS = [
    "renderDelay",
];
exports.PdfExportOptionObject = PdfExportOptionObject;
