"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
/**
 *  basic file uri, does not allow ?par... at the end
 */
const fileUriRegExp = /(['"])file:\/{3}(.+?)\1/g;
class AssertExtensions {
    /**
     *
     * @param html Converts all absolute paths like `file:///C:/test/abc.de`
     * to match the relative path `path/to/abc.de`.
     * This will the document html with all absolute file paths replaced with
     * this relative paths.
     * @param outputRoot The root dir from which the relative paths start
     */
    static removeAbsolutePaths(html, outputRoot) {
        return html.replace(fileUriRegExp, (wholeMatch, openingQuote, uri) => {
            let relativePath = path_1.default.relative(outputRoot.toString(), uri);
            return `${openingQuote}${relativePath}${openingQuote}`.replace(/\\/g, "/");
        });
    }
}
exports.default = AssertExtensions;
