"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const ConversionObject_1 = require("../../../objects/export/ConversionObject");
describe("ConversionObject", () => {
    it('creates default correctly', () => {
        let values = {
            language: "en",
            bodyOnly: false,
            automaticExtensionDetection: false,
            removeComments: false,
        };
        let inclusionObject = new ConversionObject_1.ConversionObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
        };
        let inclusionObject = new ConversionObject_1.ConversionObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
        };
        let moreValues = Object.assign({ renderDelay: 150 }, values);
        let inclusionObject = new ConversionObject_1.ConversionObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
