"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const ExtensionObject_1 = require("../../../objects/export/ExtensionObject");
describe("ExtensionObject", () => {
    it('creates default correctly', () => {
        let values = {};
        let inclusionObject = new ExtensionObject_1.ExtensionObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
        };
        let inclusionObject = new ExtensionObject_1.ExtensionObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
        };
        let moreValues = Object.assign({
            language: "de",
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
            renderDelay: 150,
        }, values);
        let inclusionObject = new ExtensionObject_1.ExtensionObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
