"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const InclusionObject_1 = require("../../../objects/export/InclusionObject");
describe("InclusionObject", () => {
    it('creates default correctly', () => {
        let values = {
            language: "en",
        };
        let inclusionObject = new InclusionObject_1.InclusionObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
        };
        let inclusionObject = new InclusionObject_1.InclusionObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
        };
        let moreValues = Object.assign({
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
            renderDelay: 150,
        }, values);
        let inclusionObject = new InclusionObject_1.InclusionObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
