"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const PdfExportOptionObject_1 = require("../../../objects/export/PdfExportOptionObject");
describe("PdfExportOptionObject", () => {
    it('creates default correctly', () => {
        let values = {
            language: "en",
            bodyOnly: false,
            automaticExtensionDetection: false,
            removeComments: false,
            renderDelay: 0,
        };
        let inclusionObject = new PdfExportOptionObject_1.PdfExportOptionObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
            renderDelay: 150,
        };
        let inclusionObject = new PdfExportOptionObject_1.PdfExportOptionObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            language: "de",
            includeQuiz: true,
            includeElearnVideo: false,
            includeClickImage: true,
            includeTimeSlider: false,
            bodyOnly: true,
            automaticExtensionDetection: true,
            removeComments: true,
            renderDelay: 150,
        };
        let moreValues = Object.assign({ exportLinkedFiles: true }, values);
        let inclusionObject = new PdfExportOptionObject_1.PdfExportOptionObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
