"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const ConverterSettingsObject_1 = require("../../../objects/settings/ConverterSettingsObject");
describe("ConverterSettingsObject", () => {
    it('creates default correctly', () => {
        let values = {
            newSectionOnHeading: true,
            headingDepth: 3,
            useSubSections: true,
            subSectionLevel: 3,
            subsubSectionLevel: 4,
        };
        let inclusionObject = new ConverterSettingsObject_1.ConverterSettingsObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            newSectionOnHeading: false,
            headingDepth: 2,
            useSubSections: false,
            subSectionLevel: 2,
            subsubSectionLevel: 5,
        };
        let inclusionObject = new ConverterSettingsObject_1.ConverterSettingsObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            newSectionOnHeading: false,
            headingDepth: 2,
            useSubSections: false,
            subSectionLevel: 2,
            subsubSectionLevel: 5,
        };
        let moreValues = Object.assign({
            newPageOnSection: false,
            contentZoom: 2,
            customHeader: "header",
            customFooter: "footer",
            headerHeight: "15cm",
            footerHeight: "2px",
            customStyleFile: "file",
            chromePath: "chrome",
            puppeteerOptions: {},
            keepChromeAlive: true,
            exportLinkedFiles: true,
        }, values);
        let inclusionObject = new ConverterSettingsObject_1.ConverterSettingsObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
