"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const PdfSettingsObject_1 = require("../../../objects/settings/PdfSettingsObject");
describe("PdfSettingsObject", () => {
    it('creates default correctly', () => {
        let values = {
            newSectionOnHeading: true,
            headingDepth: 3,
            useSubSections: true,
            subSectionLevel: 3,
            subsubSectionLevel: 4,
            newPageOnSection: true,
            contentZoom: 1,
            headerHeight: "0",
            footerHeight: "17mm",
            keepChromeAlive: false,
        };
        let inclusionObject = new PdfSettingsObject_1.PdfSettingsObject();
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly', () => {
        let values = {
            newSectionOnHeading: false,
            headingDepth: 2,
            useSubSections: false,
            subSectionLevel: 2,
            subsubSectionLevel: 5,
            newPageOnSection: false,
            contentZoom: 2,
            customHeader: "header",
            customFooter: "footer",
            headerHeight: "15cm",
            footerHeight: "2px",
            customStyleFile: "file",
            chromePath: "chrome",
            puppeteerOptions: {},
            keepChromeAlive: true,
        };
        let inclusionObject = new PdfSettingsObject_1.PdfSettingsObject(values);
        assert_1.default.deepEqual(inclusionObject, values);
    });
    it('creates from input correctly without additional keys', () => {
        let values = {
            newSectionOnHeading: false,
            headingDepth: 2,
            useSubSections: false,
            subSectionLevel: 2,
            subsubSectionLevel: 5,
            newPageOnSection: false,
            contentZoom: 2,
            customHeader: "header",
            customFooter: "footer",
            headerHeight: "15cm",
            footerHeight: "2px",
            customStyleFile: "file",
            chromePath: "chrome",
            puppeteerOptions: {},
            keepChromeAlive: true,
        };
        let moreValues = Object.assign({ exportLinkedFiles: true }, values);
        let inclusionObject = new PdfSettingsObject_1.PdfSettingsObject(moreValues);
        assert_1.default.deepEqual(inclusionObject, values);
    });
});
